#!/usr/bin/perl
#################################################################
#								#
#               PURE LIFE DREAM - Integral -                    #
#             ( Release 3.33 build 2001.6.25 )			#
#								#
#  Script coded by Song, Jae-won. at 2001/6/25			#
#  E-mail   : luciel@altavista.net				#
#                                                               #
#  Official Homepage : http://free.soranet.com/~luciel/pldbbs/  #
#		       http://my.netian.com/~luciel/pldbbs/	#
#								#
#  Adviced by Cho Kwang-hyun / Cho Sung-pil / Cho Sun-young	#
#             Han Sahng-Wook / Hong Sang-wan / Hwang Soo-yeon	#
#             Kim Woo-teak / Naoto mochizuki (ABC...)		#
#								#
#################################################################


sub parse_input {

	local($method) = $ENV{'REQUEST_METHOD'};
	if(defined(@_)) {
		local(*input) = @_;
	}
	else {
		local(*input) = "*IN";
	}

	if ($method eq 'POST') {
		read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
		$ENV{'QUERY_STRING'} = $buffer;
	}
	else {
		$buffer = $ENV{'QUERY_STRING'};
	}
	@pairs = split(/&/, $buffer);
	foreach $pair (@pairs) {
		($key, $value) = split(/=/, $pair);
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$FORM{$key} = $value;
	}

}


# ۼð
sub get_time {

	$time = time;
	local($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($time);
	$sec   = "0" . $sec  if ($sec  < 10);
	$min   = "0" . $min  if ($min  < 10);
	$hour  = "0" . $hour if ($hour < 10);
	$mday  = "0" . $mday if ($mday < 10);
	local $month = $mon + 1;
	$month = "0" . $month if ($month < 10);
	$thisday = (Sun,Mon,Tue,Wed,Thu,Fri,Sat) [$wday];
	if ($year > 99) {
		$year -= 100;
		$year = "0" . $year if ($year < 10);
		$year = "20" . $year;
	}
	else {
		$year = "19" . $year;
	}
	$wdate  = "$year/$month/$mday ($thisday) $hour:$min:$sec";
	$rdate  = "$year/$month/$mday ($thisday) $hour:$min:$sec";
	$cdate  = "$year/$month/$mday ($thisday) $hour:$min:$sec";

}


# Ű
sub admin_cookie {

	$cookie_key = $admin_id . $admin_passwd . '_cookie' ;

	@COOKIES = split(/; /,$ENV{'HTTP_COOKIE'});
	foreach (@COOKIES) {
		($ck_name,$ck_value) = split(/=/,$_);
		$COOKIE{$ck_name} = $ck_value;
	}
	($cookie_id,$cookie_passwd,$admin_icn) = split(/:/,$COOKIE{$cookie_key});
	unless ($cookie_id) {
		$cookie_id = ''; $cookie_passwd = '';
	}

}


#   üũ
sub filter_var {

	if ($html_not_use == 1) {
		foreach $key (keys %FORM) {
                        $FORM{$key} =~ s/&/&amp;/g;
                        $FORM{$key} =~ s/"/&quot;/g;
                        $FORM{$key} =~ s/&amp;#([0-9]+);/&#$1;/g;
			$FORM{$key} =~ s/</&lt;/g if ($cookie_id ne $admin_id || $admin_html == 0);
			$FORM{$key} =~ s/>/&gt;/g if ($cookie_id ne $admin_id || $admin_html == 0);
		}
	}
	foreach $key (keys %FORM) {
		if ($key ne 'comment') {
			$FORM{$key} =~ s/\n//g;
			$FORM{$key} =~ s/\|/&#124/g;
			$FORM{$key} =~ s/^\s+//;
		} elsif ($key eq 'comment') {
			$FORM{$key} =~ s/\r\n/<br>/g;
			$FORM{$key} =~ s/\r|\n/<br>/g;
			$FORM{$key} =~ s/^\s+//;
			$FORM{$key} =~ s/\|/&#124/g;
		}
	}

	if ( $FORM{'name'} eq "" || $FORM{'name'} =~ /</ ){ 
		&open_err('pldbbs' , '̸ Էµ ʾұ  Ͽ ߽ϴ.');
	}
	if ( $FORM{'comment'} eq "" ){ 
		&open_err('pldbbs' , ' Էµ ʾұ  Ͽ ߽ϴ.');
	}
        if ( $FORM{'email'} =~ /http:\/\//i || $FORM{'email'} =~ /\.\./ ){ 
		&open_err('pldbbs' , '  ԷµǾ  Ͽ ߽ϴ.');
	}

	if ( $FORM{'url'} ) {
		if ($FORM{'url'} !~ m?^http://?i ) {
			$FORM{'url'} = "http://" . $FORM{'url'};
		}
		$FORM{'url'} = '' if ( $FORM{'url'} !~ /http:\/\/.{3,}/ );
	}
	$FORM{'email'} = '' if ( $FORM{'email'} !~ /.+\@.+\..+/ );
	if ($icon_use eq '1') {
		$FORM{'icon'} = $default_icn if ( $FORM{'icon'} =~ /\.\./ || $FORM{'icon'} =~ /http:\/\//i );

		#  üũ
		foreach $icn (@kodama) {
			($ifname, $ipass) = split(/\|/,$icn);
			$FORM{'icon'} = $ifname if ($FORM{'passwd'} eq $ipass);
		}
	}

}


#   ó
sub get_icons {

	undef (@hikari); undef (@nozomi); undef (@kodama);
	open(ICNFILE, "icons.cgi") || &open_err('pldbbs', 'icons.cgi  µ ߱   ߻߽ϴ.');
	while ($icons = <ICNFILE>) {
		chomp($icons);
		if ($icons =~ m/\|/) {
			(@kotone) = split(/\|/,$icons);
			push (@hikari, $icons) if ($kotone[2] eq '1' || $kotone[2] eq '3');
			push (@nozomi, $icons) if ($kotone[2] eq '2' || $kotone[2] eq '3');
			push (@kodama, $icons) if ($kotone[2] eq '0');
		}
		elsif ($icons !~ /^#/ and $icons ne '')  {
			&open_err('pldbbs', 'icons.cgi  ų, ASCII  ϵ ʾҽϴ.');
		}
	}
	close(ICNFILE);
}

# ۼ 
sub view_write {

	print '<form method=POST action="pldbbs.cgi">', "\n";
	print '<input type=hidden name=m value="add">', "\n";
	print "<input type=hidden name=p value=$FORM{'p'}>\n";

	@signtemp = @wstyle;
	foreach $inline (@signtemp) {
		$inline =~ s/(name="name")/$1 value="$cname"/i;
		$inline =~ s/(name="email")/$1 value="$cemail"/i;
		$inline =~ s/(name="url")/$1 value="$curl"/i;
		$inline =~ s/(name="passwd")/$1 value="$cpass"/i;

                if ($inline =~ m/<!--icon_list-->/ && $icon_use eq '1') {
			foreach $icn (@hikari) {
				($ifname, $icmt) = split(/\|/,$icn);
				$icln .= "	<OPTION VALUE='$ifname'>$icmt\n" if ($ifname ne $cicon);
		 		$icln .= "	<OPTION VALUE='$ifname' SELECTED>$icmt\n" if ($ifname eq $cicon);
			}
                }
		$inline =~ s/<!--icon_list-->/$icln/i;

		print $inline;
	}

	print '</form>', "\n";
}


# ϵ  ǥ
sub view_sign {

	my ($count,$name,$email,$home,$date,$icon,$comments,$rdate,$reply,$rname,$remail,$rhome,$ricon) = split(/\|/,$_[0]);

	$resclick = "(<a href=\"pldbbs.cgi?m=rform&p=$FORM{'p'}&s=$i&c=$count\">reply</a>)";

	$comments =~ s/<br>/<br>\n/g;
	$reply =~ s/<br>/<br>\n/g;
	if ($FORM{'m'} eq 'search' && $FORM{'sname'} ne '' && $scolor ne '') {
		$comments =~ s/$FORM{'sname'}/<b><font color=$scolor>$FORM{'sname'}<\/font><\/b>/g if ($FORM{'smode'} eq 'comment');
		$reply =~ s/$FORM{'sname'}/<b><font color=$scolor>$FORM{'sname'}<\/font><\/b>/g if ($FORM{'smode'} eq 'reply');
	}

	if ($html_not_use == 1) {
		$comments =~ s/(http:\/\/[\w\.\/\~\-\+\=\#\%\&\?\(\)]+)/<A HREF="$1" TARGET="_blank">$1<\/A>/ig;
		$reply =~ s/(http:\/\/[\w\.\/\~\-\+\=\#\%\&\?\(\)]+)/<A HREF="$1" TARGET="_blank">$1<\/A>/ig;
	}
	$home = '<A HREF="' . $home . '" TARGET="new">' . $home . '</A>' if ($home ne '' && $showurl == 1) ;
	$home = '<A HREF="' . $home . '" TARGET="new">' . $urltext1 . '</A>' if ($home ne '' && $showurl == 0);
	$home = $urltext2 if ($home eq '' && $showurl eq '0');
	$name = '<A HREF="mailto:' . $email . '">' . $name . '</A>' if ($email ne '');
	$icon = $default_icn if ($icon !~ /\./);
	$ricon = $default_icn if ($ricon !~ /\./);
	$icon = '<IMG SRC="' . $icon_dir . '/' . $icon . '">';
	$ricon = '<IMG SRC="' . $icon_dir . '/' . $ricon . '">';
	$comments =~ s/&lt;(\/?(B|I|U))&gt;/<$1>/ig if ($taguse == 1);
	$reply =~ s/&lt;(\/?(B|I|U))&gt;/<$1>/ig if ($taguse == 1);

	@puttemp = @vstyle if ($reply eq '');
	@puttemp = @rstyle if ($reply ne '');
	foreach $inline (@puttemp) {
		if ( $admin == 1 ) { $inline =~ s/res<!--p-->/$resclick/i; }
		else { $inline =~ s/res<!--p-->//i; }

		$inline =~ s/num<!--p-->/$count/i;
		$inline =~ s/date<!--p-->/$date/i;
		$inline =~ s/date2<!--p-->/$rdate/i;
		$inline =~ s/name<!--p-->/$name/i;
		$inline =~ s/url<!--p-->/$home/i;
		$inline =~ s/comments<!--p-->/$comments/i;
		$inline =~ s/reply<!--p-->/$reply/i;

		if($icon eq '' || $icon_use eq '0'){ $inline =~ s/icon<!--p-->//i; }
		else { $inline =~ s/icon<!--p-->/$icon/i; }
		if($ricon eq '' || $icon_use eq '0'){ $inline =~ s/icon2<!--p-->//i; }
		else { $inline =~ s/icon2<!--p-->/$ricon/i; }

		print $inline;
	}

}


# ߻ óƾ
sub open_err {

	&fileunlock;

	local($location, $message) = @_;

	print "Content-type: text/html\n";
	print "Pragma: no-cache\n\n";

	print "<HTML><HEAD><TITLE>500 CGI internal Error</TITLE></HEAD>\n";
	print "<BODY><H1>500 CGI internal Error</H1>\n";
	print "$location  ο ߻߽ϴ. <BR><BR>\n";
	print "Please contact the webmaster <A HREF=mailto:$admin>Webmaster</A>\n";
	print "and inform them of the time occurred, and\n";
	print " anything you might have done that may have caused the error.<BR><BR>\n";
	print "<B>Error:  $message </B><BR><BR>\n";
	print "</BODY></HTML>\n";

	exit;

}


# header 
sub header_prn {

	print 'Content-type: text/html; charset=EUC-KR', "\n";
	print 'Pragma: no-cache', "\n\n";
	print '<!--   PURE LIFE DREAM - Integral - by Song, Jae-won   -->', "\n";
	print '<!--        ( Release 3.33 build 2001.6.25 )           -->', "\n";
	print '<!--          Script coded date is 2001/6/25           -->', "\n";
	print '<!--  E-mail : luciel@altavista.net                    -->', "\n";
	print '<!--  URL    : http://free.soranet.com/~luciel/pldbbs/ -->', "\n\n";

	print @hstyle;

}


# footer 
sub footer_prn {

	foreach $line (@fstyle) {
		$line =~ s/(name="sname")/$1 value="$cname"/i;
		$line =~ s/<!--bttn_bar-->//i;
		$line =~ s/bttn_pp<!--p-->/$bttn_pp/i;
		$line =~ s/page_num<!--p-->/$pages/i;
		$line =~ s/bttn_np<!--p-->/$bttn_np/i;
		print $line;
	}
}


# file lock
sub filelock {

	local($retry) = 10; local($flag) = 0;
	if ($lock eq '1') { 
		while (!symlink(".", $lockfile)) {
			if (--$retry <= 0) {
				unlink($lockfile) if (-e $lockfile);
				&open_err('pldbbs', 'file lockǾ ֽϴ.');
			}
		sleep(1);
		}
	} elsif ($lock eq '2') {
		foreach (1 .. $retry) {
			if (-e "$lockfile") { sleep(1); }
			else { open(LOCK, ">$lockfile"); close(LOCK) || &open_err('pldbbs', 'file lockǾ ֽϴ.'); $flag = 1; last; }
		}
		&open_err('pldbbs', 'file lockǾ ֽϴ.') if ($flag == 0);
	}

}


sub fileunlock { unlink($lockfile) if (-e $lockfile); }


# Cookie header 
sub put_cookie {
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = gmtime(time + 14*24*60*60);

	$thisday = (Sunday,Monday,Tuesday,Wednesday,Thursday,Friday,Saturday)[$wday];
	$month = (Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec)[$mon];
	$year += 1900 if length $year < 4;
	$year += 100 if $year <= 1970;

	$date_gmt = sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT", $thisday, $mday, $month, $year, $hour, $min, $sec);

	print "Set-Cookie: pldbbs=name \^n $FORM{'name'}\,email \^n $FORM{'email'}\,url \^n $FORM{'url'},wday \^n $cdate,icon \^n $FORM{'icon'},passwd \^n $FORM{'passwd'}; expires=$date_gmt\n";

}


# Cookie data decode
sub get_cookie {
	@key_value_pairs = split(/;\s/, $ENV{'HTTP_COOKIE'});

	foreach $key_value (@key_value_pairs) {
		($key, $value) = split(/=/, $key_value);

		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

		$cookie_data{$key} = $value;
	}

	@pairs = split(/,/,$cookie_data{pldbbs});

	foreach $pair (@pairs) {
		($key, $value) = split(/ \^n /, $pair);
		$cookie{$key} = $value;
	}

	$cname = $cookie{'name'};
	$cemail = $cookie{'email'};
	$curl = $cookie{'url'};
	$wday = $cookie{'wday'};
	$cicon = $cookie{'icon'};
	$cpass = $cookie{'passwd'};

}


1;